#!/bin/bash -l

cat << 'EOF'
#!/bin/bash -l

#SBATCH --nodes=1
#SBATCH --constraint=hwperf
#SBATCH --time=01:00:00
#SBATCH --export=None
#SBATCH --exclusive
#SBATCH --output=%x.o%j.log
#SBATCH --err=%x.o%j.err
EOF

#Interpreted string
cat << EOF
# BUILD VARIABLES
USE_MPI="${USE_MPI}"
USE_CUDA="${USE_CUDA}"
USE_HIP="${USE_HIP}"
USE_OMP="${USE_OMP}"
VISABLE_DEVICE="${VISABLE_DEVICE:-"0"}"

BENCHMARKS_TO_BUILD="${BENCHMARKS_TO_BUILD}"

PERF_GROUP="${PERF_GROUP:-"MEM_DP"}"
# Repository
WALBERLA_GITLAB_INSTANCE="${WALBERLA_GITLAB_INSTANCE}"
WALBERLA_PROJECT_ID="${WALBERLA_PROJECT_ID}"
WALBERLA_BRANCH="${WALBERLA_BRANCH}"
WALBERLA_COMMIT="${WALBERLA_COMMIT}"
EOF
cat << 'EOF'
WALBERLA_URL="${WALBERLA_GITLAB_INSTANCE}/${WALBERLA_PROJECT_ID}"
EOF


cat << 'EOF'

MODULEPATH=$MODULEPATH:/opt/modules/modulefiles/testcluster
module avail likwid

module load likwid/5.2.2
module load cmake

[ "${USE_CUDA}" = "ON" ] && module load cuda
[ "${USE_MPI}" = "ON" ] && module load openmpi/4.1.1-gcc9.3-legacy

module list

# Set ENVVARIABLES for testcluster
export LD_LIBRARY_PATH=$LIBRARY_PATH:$LD_LIBRARY_PATH
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/opt/slurm/current-u2004/lib/
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/opt/slurm/23.02.3/lib/
export LC_CTYPE=C

# Directory Setup
BASE_DIR="/scratch"
[ -d "${BASE_DIR}" ] || BASE_DIR="${WORK}"
SOURCE_DIR="walberla_ci"
FULL_PATH="${BASE_DIR}/${SOURCE_DIR}"
BUILD_DIR="${FULL_PATH}/build"
PYTHON_VENV="${WORK}/walberla_venv"

EOF
